/*
    AllegroBobble - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Alessandro Francesco De Rosis

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BALL_H
#define BALL_H


#include "Allegro.h"
#include "Sprite.h"
# include <queue>


class PuzzleBubble;

enum Tipo{ROSSA=0,BLU,GIALLA,VERDE,VIOLA,NULLO};
class Ball : public Sprite 
{
public:
    Ball(PuzzleBubble& game, const Point& center);
    Ball(PuzzleBubble& game, const Point& center, string imageName);
    Ball(bool hit_,PuzzleBubble& game, const Point& center);
    virtual Drawable* clone() const { return new Ball(*this); }
 
    virtual bool alive() const;
 
     bool operator==(const Ball& right) {return getLeftTopCorner().getX()==right.getLeftTopCorner().getX() && getLeftTopCorner().getY()==right.getLeftTopCorner().getY() && t==right.t;}
     
     bool operator!=(const Ball& right) {return !(*this== right);}
    void lancia();

private:
    PuzzleBubble& game;
    Tipo t;
    bool hit;
   
    SampleSound boom;
    
    string imageName(int) const ;
    Tipo getTipo() const;
    void lancioDaPareteDiSinistra(int a,int b);
    void lancioDaPareteDiDestra(int a,int b);
    bool toccaPareteSinistra(Ball* c) const ;
    bool toccaPareteDestra(Ball* c) const ;
    bool toccaPareteInAlto(Ball* c) const ;
    int dammiRestoDallePareti(Ball* c) const ;
    bool urto(Ball* c) ;
    void impostaPallinaDopoUrto(Ball* da_set, const Ball* urtata,bool &gia_impostato) ;
    void scoppio();
    int distanza(Ball* b, Ball* c) const; 
    bool ricerca(queue<Ball*>,Ball*) const;
    bool check_collegamento(Ball* c) const;
    queue<Ball*>  collegamenti_generici(Ball* c) const;
 

};


#endif
