/*
    AllegroBobble - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Alessandro Francesco De Rosis

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Font.h"

list<pair<string, FONT*> > Font::instances;

Font::Font() {
    data = font;
}

Font::Font(const string& filename) {
    for(list<pair<string, FONT*> >::const_iterator it = instances.begin(); it != instances.end(); ++it) {
        if(it->first == filename) {
            data = it->second;
            return;
        }
    }
    
    data = load_font(filename.c_str(), NULL, NULL); 
    assert(data != NULL);
    instances.push_back(pair<string, FONT*>(filename, data));
}

Font::Font(const Font& init) : data(init.data) {

}

Font::~Font() {
}
