/*
    AllegroBobble - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Alessandro Francesco De Rosis

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PUZZLE_BUBBLE_H
#define PUZZLE_BUBBLE_H

# include "Allegro.h"
#include "viewIndicator.h"
#include <list>
#include <queue>

#include "Ball.h"
class PuzzleBubble: public Allegro
{
   friend class Ball;
public:
   PuzzleBubble();
   virtual ~PuzzleBubble();
  

   virtual void onTick();

   
private:
   
   ViewIndicator freccia;
   
   CompositeSprite backgroundLayer;
   CompositeSprite middleLayer;
   CompositeSprite topLayer;
   
   list<Ball*> inserite;
   queue<Ball*> daInserire;
   void aggiungiADaInserire();

   bool gameOver;
   bool isGameOver() ;

   void aggiungiRiga();
   void scala();

   int level;
   Text levelText;
   
   int point;
   Text pointText;
  
   SampleSound game_over;
   SampleSound backgroundSound;
   SampleSound shot;
   
   int y_muro;  
};
#endif
